---
title: Firefox 55 for developers
slug: Mozilla/Firefox/Releases/55
tags:
  - '55'
  - Firefox
  - Release Notes
---
<div>{{FirefoxSidebar}}</div><article class="text-content" id="wikiArticle">
<p>Firefox 55 was released on August 8, 2017. This article lists key changes that are useful for web developers.</p>

<h2 id="Changes_for_Web_developers">Changes for Web developers</h2>

<h3 id="Developer_Tools">Developer Tools</h3>

<ul>
 <li>Added filtering of network requests by column values and other properties ({{bug(1041895)}}, {{bug(1354508)}}, {{bug(1354507)}}) and by using regular expressions ({{bug(1354495)}}).</li>
 <li>Made it possible to show and hide columns within the <a href="/en-US/docs/Tools/Network_Monitor">Network Monitor</a> ({{bug(862855)}}).</li>
 <li>Added remote IP ({{bug(1344523)}}), protocol ({{bug(1345489)}}), scheme ({{bug(1356867)}}), cookies and set cookies columns ({{bug(1356869)}}) to Network Monitor.</li>
 <li>The {{HTTPHeader("SourceMap")}} HTTP header is now supported (prior versions supported the deprecated <code>X-SourceMap</code> header, see {{bug(1346936)}}).</li>
</ul>

<h3 id="HTML">HTML</h3>

<ul>
 <li>Elements on which {{htmlattrxref("contenteditable")}} has been set to <code>true</code> now use {{htmlelement("div")}} elements to separate different lines of text, to give Firefox parity with other modern browsers ({{bug(1297414)}}). See <a href="/en-US/docs/Web/Guide/HTML/Editable_content#Differences_in_markup_generation">Differences in markup generation</a> for more details.</li>
 <li>Enable <code>dom.forms.datetime</code> by default on Nightly ({{bug(1366188)}}).</li>
</ul>

<h3 id="CSS">CSS</h3>

<ul>
 <li>Exposed the {{cssxref("transform-box")}} property by default ({{bug(1208550)}}).</li>
 <li>Implemented the <a href="/en-US/docs/Web/CSS/single-transition-timing-function#The_frames()_class_of_timing-functions">frames() timing function</a> ({{bug(1248340)}}).</li>
 <li>Implemented the {{cssxref("text-justify")}} property ({{bug(1343512)}}, {{bug("276079")}}).</li>
 <li>[css-grid] {{cssxref("fit-content")}} unexpectedly reserves space for full clamp size in {{cssxref("repeat()")}} ({{bug(1359060)}}).</li>
 <li>The {{cssxref("float")}} / {{cssxref("clear")}} logical values — <code>inline-start</code> and <code>inline-end</code> — which were previously implemented but preffed off in release channels, are now available in all channels by default ({{bug(1253919)}}).</li>
 <li>The <code>layout.css.variables.enabled</code> preference has been removed completely meaning that the <a href="/en-US/docs/Web/CSS/Using_CSS_variables">CSS variables</a> feature is enabled all the time and can no longer be disabled ({{bug(1312328)}}).</li>
 <li>Implemented the proprietary {{cssxref("-moz-context-properties")}} property ({{bug(1058040)}}).</li>
 <li>Zero (0) angle value without degree unit is not correctly interpreted in {{cssxref("linear-gradient")}} ({{bug(1363292)}}).</li>
 <li>The {{cssxref("::cue")}} pseudo-element is now supported; it matches on text cues presented within a media element ({{bug(1318542)}}).</li>
</ul>

<h3 id="SVG">SVG</h3>

<ul>
 <li>The {{svgelement("radialGradient")}} {{ SVGAttr("fr") }} attribute has been implemented ({{bug("1240275")}}).</li>
</ul>

<h3 id="JavaScript">JavaScript</h3>

<ul>
 <li>The {{jsxref("SharedArrayBuffer")}} and {{jsxref("Atomics")}} objects are now enabled by default. See <a href="https://hacks.mozilla.org/2016/05/a-taste-of-javascripts-new-parallel-primitives/">A Taste of JavaScript’s New Parallel Primitives</a> for an introduction to JavaScript Shared Memory and Atomics.</li>
 <li>The rest operator (<code>...</code>) is now supported in <a href="/en-US/docs/Web/JavaScript/Reference/Operators/Destructuring_assignment">object destructuring</a> and the spread operator (<code>...</code>) now works in <a href="/en-US/docs/Web/JavaScript/Reference/Operators/Spread_operator#Spread_in_object_literals">object literals</a> (Stage 3 ECMAScript proposal: <a href="https://github.com/tc39/proposal-object-rest-spread">Object Rest/Spread Properties</a>, {{bug(1339395)}}).</li>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Functions/Method_definitions#Async_generator_methods">Async generator methods</a> are now supported ({{bug(1353693)}}).</li>
 <li>The {{jsxref("String.prototype.toLocaleLowerCase()")}} and {{jsxref("String.prototype.toLocaleUpperCase()")}} methods now support an optional <code>locale</code> parameter to specify a language tag for locale-specific case mappings ({{bug(1318403)}}).</li>
 <li>The {{jsxref("Collator", "Intl.Collator")}} object now supports the <code>caseFirst</code> option ({{bug(866473)}}).</li>
 <li>The <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Intl">Intl API</a> now uses the browser's default locale instead of the operating system's default locale when no locale setting is provided ({{bug(1346674)}}).</li>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Template_literals">Template call sites objects</a> are now canonicalized per realm, based upon their list of raw strings ({{bug(1108941)}}).</li>
 <li>{{jsxref("TypedArray")}} constructors (like {{jsxref("Int8Array")}}, {{jsxref("Float32Array")}}, etc.) have been updated to ES2017. They now use the <code>ToIndex</code> operation and allow constructors without arguments, which return zero-length typed arrays ({{bug(1317383)}}).</li>
</ul>

<h3 id="APIs">APIs</h3>

<h4 id="New_APIs">New APIs</h4>

<ul>
 <li>The <strong><a href="/en-US/docs/Web/API/Background_Tasks_API">Collaborative Scheduling of Background Tasks API</a></strong> (also known as the <strong>Background Tasks API</strong> or the <strong><code>requestIdleCallback</code> API</strong>) is now enabled by default after being available behind a preference since Firefox 53. This API lets you schedule tasks to be executed when the browser determines that there's free time available before the next repaint occurs, so that your code can make use of that time without causing visible performance lag ({{bug(1314959)}}).</li>
 <li>The <strong><a href="/en-US/docs/Web/API/WebVR_API">WebVR 1.1 API</a></strong> is now turned on by default on Windows (and is available on macOS in Nightly). This API exposes virtual reality devices — for example head-mounted displays like the Oculus Rift or HTC Vive — to web apps, enabling developers to translate position and movement information from the display into movement around a 3D scene, and present content into such displays.</li>
 <li>The <strong><a href="/en-US/docs/Web/API/Intersection_Observer_API">Intersection Observer API</a></strong> — which provides a way to asynchronously observe changes in the intersection of a target element with an ancestor element or with a top-level document's <a href="/en-US/docs/Glossary/viewport" title="viewport: A viewport represents a polygonal (normally rectangular) area in computer graphics that is currently being viewed. In web browser terms, it refers to the part of the document you're viewing which is currently visible in its window. Content outside the viewport is currently not displayed onscreen.">viewport</a> — has been added ({{bug(1321865)}}).</li>
</ul>

<h4 id="DOM">DOM</h4>

<ul>
 <li>The {{domxref("Window")}} properties {{domxref("Window.scrollX", "scrollX")}} and {{domxref("Window.scrollY", "scrollY")}} (as well as their aliases {{domxref("Window.pageXOffset", "pageXOffset")}} and {{domxref("Window.pageYOffset", "pageYOffset")}}) have been updated to be subpixel precise. Instead of returning an integer, these now return a floating-point value which more accurately describes the scroll position on subpixel-precise displays ({{bug(1151421)}}). If need be, you can use {{jsxref("Math.round()")}} to convert them into integers.</li>
 <li>{{domxref("MediaQueryList")}} (and other related features) have been updated to match the latest spec. See {{bug("1354441")}}, and also see {{domxref("MediaQueryList")}} and {{domxref("MediaQueryListEvent")}}.</li>
 <li>Methods of the {{domxref("DOMTokenList")}} that modify the list value now automatically trim whitespace and remove duplicate tokens ({{bug("869788")}}, also see <a href="/en-US/docs/Web/API/DOMTokenList#Trimming_of_whitespace_and_removal_of_duplicates">Trimming of whitespace and removal of duplicates</a>).</li>
 <li>The {{domxref("HTMLInputElement")}}'s <code>maxLength</code> property can now be dynamically altered with JavaScript after the equivalent HTML has been created ({{bug(1352799)}}).</li>
 <li>The {{domxref("URL.URL", "URL()")}} constructor can no longer accept a {{domxref("DOMString")}} as its base (2nd parameter) — it only accepts a {{domxref("USVString")}}. It can still use an existing {{domxref("URL")}} object for the base, which stringifies itself to the object's {{domxref("DOMString.href","href")}} attribute ({{bug(1368950)}}).</li>
</ul>

<h4 id="DOM_events">DOM events</h4>

<ul>
 <li>The event types supported by the {{domxref("Document.createEvent()")}} method have been updated as per the latest DOM spec ({{bug(1251198)}}).</li>
 <li>The {{domxref("MessageEvent.origin")}} property value is now of type {{domxref("USVString")}}, not {{domxref("DOMString")}}, and the {{domxref("MessageEvent.source")}} property now takes a <code>MessageEventSource</code> value (which can be a {{domxref("WindowProxy")}}, {{domxref("MessagePort")}}, or {{domxref("ServiceWorker")}} object) ({{bug(1311324)}}).</li>
 <li>The pinch-to-zoom gesture has now been mapped to the {{event("wheel")}} event plus the + <kbd>Ctrl</kbd> key. This mapping was implemented to allow developers to implement simple zooming functionality using the pinch-to-zoom gesture on mobile screens/trackpads (mousewheel + <kbd>Ctrl</kbd> commonly zooms) ({{bug(1052253)}}).</li>
</ul>

<h4 id="Selection_API">Selection API</h4>

<ul>
 <li>The <a href="/en-US/docs/Web/API/Selection_API">Selection API</a> has been updated so that it has parity with other browsers in terms of how editing hosts are given focus when the selection moves inside them ({{bug("1318312")}}). See <a href="/en-US/docs/Web/API/Selection#Behavior_of_Selection_API_in_terms_of_editing_host_focus_changes">Behavior of Selection API in terms of editing host focus changes</a> for more details.</li>
 <li>The {{domxref("Selection")}} API has been updated to match some recent spec changes ({{bug(1359371)}}):
  <ul>
   <li>The {{domxref("Selection.collapse", "collapse()")}} and {{domxref("Selection.extend", "extend()")}} methods' <code>offset</code> parameter is now optional.</li>
   <li>The {{domxref("Selection.collapse", "collapse()")}} method's <code>node</code> parameter is now nullable.</li>
   <li>The {{domxref("Selection.containsNode", "containsNode()")}} method's <code>partialContainment</code> parameter is now optional.</li>
   <li>The {{domxref("Selection.deleteFromDocument", "deleteFromDocument()")}} method has been added.</li>
  </ul>
 </li>
 <li>Also in the {{domxref("Selection")}} API, <code>Selection.empty()</code> and <code>Selection.setPosition()</code> have been added as aliases of {{domxref("Selection.removeAllRanges()")}} and {{domxref("Selection.collapse()")}}, for web compat and WebKit/Blink parity reasons ({{bug(1359387)}}).</li>
 <li>The {{domxref("StorageManager.persist()")}} and {{domxref("StorageManager.persisted()")}} methods of the <a href="/en-US/docs/Web/API/Storage_API">Storage API</a> have been implemented and exposed to <code>Window</code> contexts ({{bug(1286717)}}).</li>
</ul>

<h4 id="Workers">Workers</h4>

<ul>
 <li>Workers and shared workers can now be created with an identifying <code>name</code> property. See the {{domxref("Worker.Worker", "Worker()")}} and {{domxref("SharedWorker.SharedWorker", "SharedWorker()")}} constructors, and the {{domxref("DedicatedWorkerGlobalScope")}} and {{domxref("SharedWorkerGlobalScope")}} interfaces. ({{bug(1364297)}}).</li>
 <li>{{domxref("WindowOrWorkerGlobalScope.setTimeout","setTimeout()")}} and {{domxref("WindowOrWorkerGlobalScope.setInterval","setInterval()")}} are now subject to minimum interval throttling for tracking scripts in background tabs — see <a href="/en-US/docs/Web/API/WindowOrWorkerGlobalScope/setTimeout#Throttling_of_tracking_timeout_scripts">Throttling of tracking timeout scripts</a> ({{bug(1355311)}}).</li>
</ul>

<h4 id="Service_WorkersPush">Service Workers/Push</h4>

<ul>
 <li>Messages sent to service worker contexts (e.g. as the event object of {{domxref("ServiceWorkerGlobalScope.onmessage","onmessage")}} are now represented by {{domxref("MessageEvent")}} objects, for consistency with other web messaging features. They used to be represented by {{domxref("ServiceWorkerMessageEvent")}} objects, which have now been deprecated ({{bug(1311324)}}).</li>
 <li>The {{domxref("PushManager.subscribe()")}} method now accepts {{domxref("ArrayBuffer")}}s and Base64-encoded strings as <code>applicationServerKey</code> values ({{bug(1337348)}}).</li>
</ul>

<h4 id="Web_Audio_API">Web Audio API</h4>

<ul>
 <li>A non-standard constructor (which accepted a string enum value indicating the purpose for which the context would be used) for {{domxref("AudioContext")}} interface was causing errors to be thrown when the <code>options</code> parameter was provided. We have removed the non-standard constructor. However, please note that the <code>options</code> parameter is not yet supported in Firefox and is currently ignored ({{bug(1361475)}}).</li>
</ul>

<h4 id="WebRTC">WebRTC</h4>

<ul>
 <li>{{domxref("mediaDevices.getUserMedia", "getUserMedia()")}} now provides a stereo audio stream by default if the source device provides stereo sound; support to specifically request mono input will come in <a href="/en-US/docs/Mozilla/Firefox/Releases/56">Firefox 56</a>. This only works on desktop at this time; mobile Firefox does not currently support stereo audio input sources ({{bug(971528)}}).</li>
 <li>The <code>getUserMedia()</code> <a href="/en-US/docs/Web/API/Media_Streams_API/Constraints">media capabilities, constraints, and settings</a> <code>autoGainControl</code> and <code>noiseSuppression</code> now match the spec; formerly they were <code>moz</code>-prefixed ({{bug(1366415)}}).</li>
 <li>When called with an empty constraints set, <code>getUserMedia()</code> was incorrectly returning <code>NotSupportedError</code> instead of <code>TypeError</code>. This has been fixed ({{bug(1349480)}}).</li>
 <li>The following new WebRTC statistics are available: <code>framesEncoded</code>, <code>pliCount</code>, <code>nackCount</code>, and <code>firCount</code> ({{bug(1348657)}}).</li>
 <li>The <code>RTCInboundRTPStreamStats</code> dictionary field formerly called <code>mozRtt</code> has been renamed to <code>roundTripTime</code> to match the specification; in addition, its behavior has been adjusted to match the standard: it contains a double-precision floating point value which estimates the round-trip time based on the RTCP timestamps in the RTCP Receiver Report, measured in seconds (following the algorithm described in {{RFC(3550, "", "6.4.1")}}). ({{bug(1344970)}}). However, please be aware that <em>this property is moving</em> to a different dictionary (<code>RTCRemoteInboundRTPStreamStats</code>) soon ({{bug(1380555)}}).</li>
 <li>The <code>RTCRTPStreamStats</code> dictionary now includes the fields <code>firCount</code>, <code>pliCount</code>, and <code>nackCount</code>. These return low-level information that can be used to determine how reliable the connection is ({{bug(1348657)}}).</li>
 <li>The <code>RTCOutboundRTPStreamStats</code> dictionary now includes the field <code>framesEncoded</code>, which reports the number of frames that have been successfully encoded for the stream; with this information, you can compute the frame rate ({{bug(1348657)}}).</li>
 <li>On Android, there's now a <a href="https://bugzilla.mozilla.org/show_bug.cgi?id=1265755#c36">pref</a> to turn on hardware video encoding to improve video call performance and save on battery. To be enabled by default in <a href="/en-US/docs/Mozilla/Firefox/Releases/56">Firefox 56</a> ({{bug(1265755)}}).</li>
</ul>

<h4 id="Encrypted_Media_Extensions_API">Encrypted Media Extensions API</h4>

<ul>
 <li>Firefox currently allows Encrypted Media Extensions to be used in insecure contexts, despite this not being allowed in the specification. This will be changed in the near future, and starting in Firefox 55, deprecation warnings are ouptut to the <a href="/en-US/docs/Tools/Web_Console">web console</a> when this is done. ({{bug(1361000)}}).</li>
 <li>Firefox currently doesn't require that at least one {{domxref("MediaKeySystemCapabilities")}} object be included in the <code>suggestedConfigurations</code> parameter passed into {{domxref("Navigator.requestMediaKeySystemAccess()")}}, which the specification does mandate. Starting in Firefox 55, a warning is output to the web console when any audio or video configuration is specified without specifying supported codecs. Soon, failure to include a valid configuration for one or more of audio and video will throw an exception {{bug(1368683)}}).</li>
</ul>

<h4 id="WebGL">WebGL</h4>

<ul>
 <li>The {{domxref("WEBGL_compressed_texture_s3tc_srgb")}} extension is now available to <a href="/en-US/docs/Web/API/WebGL_API">WebGL</a> and <a href="/en-US/docs/Web/API/WebGL2RenderingContext">WebGL2</a> contexts ({{bug(1325113)}}).</li>
</ul>

<h3 id="Security">Security</h3>

<ul>
 <li>The {{domxref("Geolocation")}} API is now available only to <a href="/en-US/docs/Web/Security/Secure_Contexts">secure contexts</a> ({{bug(1072859)}}).</li>
 <li>The {{domxref("Storage API")}} is now available only to <a href="/en-US/docs/Web/Security/Secure_Contexts">secure contexts</a> ({{bug(1268804)}}).</li>
 <li>The loading of mixed content is now allowed on localhost ({{bug(903966)}}).</li>
 <li>Loading of remote JAR files has been disabled again ({{bug(1329336)}}). See <a href="/en-US/docs/Mozilla/Security/Security_and_the_jar_protocol">Security and the jar protocol</a> for the full story.</li>
</ul>

<h3 id="Plugins">Plugins</h3>

<ul>
 <li>Flash content is now "click-to-activate" ({{bug(1317856)}}). This was immediately put into effect for all users of Nightly, and 50% of beta users. For Firefox 55 release version, the plan is to activate this for 5% of users 2 weeks after release, 25% of users 4 weeks after release, and 100% of users 6 weeks after release ({{bug(1365714)}}).</li>
 <li>Flash and other plugins can no longer be loaded from any URL scheme except for <code>http://</code> and <code>https://</code> ({{bug("1335475")}}).</li>
</ul>

<h3 id="Other">Other</h3>

<ul>
 <li>Firefox on Linux can now be made to run in <a href="/en-US/docs/Mozilla/Firefox/Headless_mode">headless mode</a> using the <code>-headless</code> flag (see {{bug(1356681)}}).</li>
</ul>

<h2 id="Removals_from_the_web_platform">Removals from the web platform</h2>

<h3 id="HTML_2">HTML</h3>

<ul>
 <li>The <code>xml:base</code> attribute can no longer be used to set the base URL for paths appearing in the {{htmlattrxref("style")}} attribute, for example —

  <p><code>&lt;div xml:base="https://example.com/" style="background:url(picture.jpg)"&gt;&lt;/div&gt;</code> ({{bug(1350521)}}). See also <a href="https://www.fxsitecompat.com/en-CA/docs/2017/xml-base-for-style-attribute-has-been-disabled/">xml:base for style attribute has been disabled</a>.</p>
 </li>
 <li>
  <p>The {{htmlelement("style")}} element's {{htmlattrxref("scoped","style")}} attribute has been hidden behind a pref (<code>layout.css.scoped-style.enabled</code>) in content documents in Firefox 55+, as no other browsers support it.</p>
 </li>
 <li>
  <p>Support for the obscure <code>MSThemeCompatible</code> value of the {{htmlelement("meta")}} element's {{htmlattrxref("http-equiv","meta")}} attribute has been removed from Gecko. No other modern browsers support it, and it was <a href="https://www.fxsitecompat.com/en-CA/docs/2017/checkboxes-and-radio-buttons-are-not-displayed-when-msthemecompatible-is-no/">causing compatibility problems</a> ({{bug("966240")}}).</p>
 </li>
</ul>

<h3 id="CSS_2">CSS</h3>

<ul>
 <li>The proprietary <code>:-moz-bound-element</code> pseudo-class has been removed ({{bug(1350147)}}).</li>
 <li>The proprietary <code>-moz-anchor-decoration</code> value of {{cssxref("text-decoration-line")}} has been removed ({{bug(1355734)}}).</li>
</ul>

<h3 id="APIs_2">APIs</h3>

<ul>
 <li>The {{domxref("UIEvent.isChar")}} property has never been supported by any browser but Firefox, and it has never been fully-implemented except on macOS. For that reason, it was removed in Firefox 55 to align with other browsers.</li>
 <li>The proprietary Firefox OS Device Storage API has been removed from the platform ({{bug(1299500)}}).</li>
 <li>The <code>aShowDialog</code> parameter of the non-standard {{domxref("Window.find()")}} method (which could be specified to open up a "Find" dialog in the browser) has been removed ({{bug(1348409)}}).</li>
 <li>The <code>HTMLFormElement.requestAutoComplete()</code> method has been removed (see {{domxref("HTMLFormElement")}}) ({{bug(1270740)}}).</li>
 <li>The non-standard, Mozilla-specific, WebRTC offer options <code>mozDontOfferDataChannel</code> and <code>mozBundleOnly</code> have been removed from the <code><a href="/en-US/docs/Web/API/RTCPeerConnection/createOffer#RTCOfferOptions_dictionary">RTCOfferOptions</a></code> dictionary and are no longer supported by {{domxref("RTCPeerConnection.createOffer()")}} ({{bug(1196974)}}).</li>
 <li>Support for the proprietary Firefox OS <a href="/en-US/docs/Archive/B2G_OS/API/Audio_Channels_API">Audio Channels API</a> has been removed from {{domxref("HTMLMediaElement")}} and {{domxref("AudioContext")}} ({{bug(1358061)}}).</li>
</ul>

<h3 id="SVG_2">SVG</h3>

<ul>
 <li>The <code>SVGZoomEvent</code> and <code>SVGZoomEvents</code> interfaces have been removed from the SVG2 spec and Gecko, along with the <code>onzoom &lt;svg&gt;</code> attribute ({{bug(1314388)}}).</li>
</ul>

<h2 id="Changes_for_add-on_and_Mozilla_developers">Changes for add-on and Mozilla developers</h2>

<h3 id="WebExtensions">WebExtensions</h3>

<ul>
 <li><a href="https://developer.mozilla.org/en-US/Add-ons/WebExtensions/API/contextMenus/create">contextMenus.create()'s command property enables you to open browser action popups, page action popups, and sidebars from the context menu.</a></li>
 <li><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/proxy">proxy API</a></li>
 <li><a href="https://developer.mozilla.org/en-US/Add-ons/WebExtensions/manifest.json/chrome_settings_overrides">chrome_settings_overrides key enables you to override the browser's homepage.</a></li>
 <li>browser_style property enables you to have browser-like styling for <a href="https://developer.mozilla.org/en-US/Add-ons/WebExtensions/manifest.json/browser_action">browser action popups</a>, <a href="https://developer.mozilla.org/en-US/Add-ons/WebExtensions/manifest.json/sidebar_action">sidebars</a>, and <a href="https://developer.mozilla.org/en-US/Add-ons/WebExtensions/manifest.json/options_ui">options pages</a>.</li>
 <li><a href="https://developer.mozilla.org/en-US/Add-ons/WebExtensions/API/permissions">permissions API</a></li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://www.fxsitecompat.com/en-US/versions/55">Site Compatibility for Firefox 55</a></li>
</ul>

<h2 id="Older_versions">Older versions</h2>

<p>{{Firefox_for_developers(54)}}</p>
</article>
